import{S as po,i as mo,s as fo,e as o,k,w as T,t as a,M as ho,c as n,d as s,m as $,a as r,x as A,h as l,b as d,G as e,g as f,y as M,q,o as z,B as P,v as uo,L as Ya}from"../../chunks/vendor-hf-doc-builder.js";import{T as Wa}from"../../chunks/Tip-hf-doc-builder.js";import{Y as io}from"../../chunks/Youtube-hf-doc-builder.js";import{I as ya}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as Q}from"../../chunks/CodeBlock-hf-doc-builder.js";import{D as co}from"../../chunks/DocNotebookDropdown-hf-doc-builder.js";import{F as hl,M as ra}from"../../chunks/Markdown-hf-doc-builder.js";function _o(V){let p,i,m,y,w,v,x,D,b,j,L,F,S,H,B,ie,G,C,le,U,X,O,W,N,c,E,Y,ue,Z,K,oe,Fe,te,Ae,ce,we,ge,ve,J,Me,ae,he,pe,ke,xe,qe,ne,re,se,me,fe,$e,u,R,de,ye,g,I,je,be,Ee,ee,Ce,ze,Se,Te,Pe,Xe,He,We,Oe,Be,Ye,os,Ze,et,It,Re,ns,Tt,mt,rs,At,ft,is,Ot,Ie,Ve,Mt,Ne,ps,qt,ht,Nt,tt,st,Qe,ms,Ge,fs,hs,at,lt,St,_e,us,zt,ut,cs,Pt,ct,ds,Rt,dt,_s,ot,Ke,gs,ks,nt,rt,Ht,Le,$s,Lt,_t,ys,Dt,gt,bs;return{c(){p=a(`You can finetune other architectures for masked language modeling following the same steps in this guide.
Choose one of the following architectures:

`),i=o("p"),m=o("a"),y=a("ALBERT"),w=a(", "),v=o("a"),x=a("BART"),D=a(", "),b=o("a"),j=a("BERT"),L=a(", "),F=o("a"),S=a("BigBird"),H=a(", "),B=o("a"),ie=a("CamemBERT"),G=a(", "),C=o("a"),le=a("ConvBERT"),U=a(", "),X=o("a"),O=a("Data2VecText"),W=a(", "),N=o("a"),c=a("DeBERTa"),E=a(", "),Y=o("a"),ue=a("DeBERTa-v2"),Z=a(", "),K=o("a"),oe=a("DistilBERT"),Fe=a(", "),te=o("a"),Ae=a("ELECTRA"),ce=a(", "),we=o("a"),ge=a("ERNIE"),ve=a(", "),J=o("a"),Me=a("ESM"),ae=a(", "),he=o("a"),pe=a("FlauBERT"),ke=a(", "),xe=o("a"),qe=a("FNet"),ne=a(", "),re=o("a"),se=a("Funnel Transformer"),me=a(", "),fe=o("a"),$e=a("I-BERT"),u=a(", "),R=o("a"),de=a("LayoutLM"),ye=a(", "),g=o("a"),I=a("Longformer"),je=a(", "),be=o("a"),Ee=a("LUKE"),ee=a(", "),Ce=o("a"),ze=a("mBART"),Se=a(", "),Te=o("a"),Pe=a("Megatron-BERT"),Xe=a(", "),He=o("a"),We=a("MobileBERT"),Oe=a(", "),Be=o("a"),Ye=a("MPNet"),os=a(", "),Ze=o("a"),et=a("MVP"),It=a(", "),Re=o("a"),ns=a("Nezha"),Tt=a(", "),mt=o("a"),rs=a("Nystr\xF6mformer"),At=a(", "),ft=o("a"),is=a("Perceiver"),Ot=a(", "),Ie=o("a"),Ve=a("QDQBert"),Mt=a(", "),Ne=o("a"),ps=a("Reformer"),qt=a(", "),ht=o("a"),Nt=a("RemBERT"),tt=a(", "),st=o("a"),Qe=a("RoBERTa"),ms=a(", "),Ge=o("a"),fs=a("RoBERTa-PreLayerNorm"),hs=a(", "),at=o("a"),lt=a("RoCBert"),St=a(", "),_e=o("a"),us=a("RoFormer"),zt=a(", "),ut=o("a"),cs=a("SqueezeBERT"),Pt=a(", "),ct=o("a"),ds=a("TAPAS"),Rt=a(", "),dt=o("a"),_s=a("Wav2Vec2"),ot=a(", "),Ke=o("a"),gs=a("XLM"),ks=a(", "),nt=o("a"),rt=a("XLM-RoBERTa"),Ht=a(", "),Le=o("a"),$s=a("XLM-RoBERTa-XL"),Lt=a(", "),_t=o("a"),ys=a("X-MOD"),Dt=a(", "),gt=o("a"),bs=a("YOSO"),this.h()},l(Ue){p=l(Ue,`You can finetune other architectures for masked language modeling following the same steps in this guide.
Choose one of the following architectures:

`),i=n(Ue,"P",{});var _=r(i);m=n(_,"A",{href:!0});var Ds=r(m);y=l(Ds,"ALBERT"),Ds.forEach(s),w=l(_,", "),v=n(_,"A",{href:!0});var ws=r(v);x=l(ws,"BART"),ws.forEach(s),D=l(_,", "),b=n(_,"A",{href:!0});var kt=r(b);j=l(kt,"BERT"),kt.forEach(s),L=l(_,", "),F=n(_,"A",{href:!0});var js=r(F);S=l(js,"BigBird"),js.forEach(s),H=l(_,", "),B=n(_,"A",{href:!0});var De=r(B);ie=l(De,"CamemBERT"),De.forEach(s),G=l(_,", "),C=n(_,"A",{href:!0});var Fs=r(C);le=l(Fs,"ConvBERT"),Fs.forEach(s),U=l(_,", "),X=n(_,"A",{href:!0});var $t=r(X);O=l($t,"Data2VecText"),$t.forEach(s),W=l(_,", "),N=n(_,"A",{href:!0});var Cs=r(N);c=l(Cs,"DeBERTa"),Cs.forEach(s),E=l(_,", "),Y=n(_,"A",{href:!0});var Bs=r(Y);ue=l(Bs,"DeBERTa-v2"),Bs.forEach(s),Z=l(_,", "),K=n(_,"A",{href:!0});var Wt=r(K);oe=l(Wt,"DistilBERT"),Wt.forEach(s),Fe=l(_,", "),te=n(_,"A",{href:!0});var Is=r(te);Ae=l(Is,"ELECTRA"),Is.forEach(s),ce=l(_,", "),we=n(_,"A",{href:!0});var Os=r(we);ge=l(Os,"ERNIE"),Os.forEach(s),ve=l(_,", "),J=n(_,"A",{href:!0});var Yt=r(J);Me=l(Yt,"ESM"),Yt.forEach(s),ae=l(_,", "),he=n(_,"A",{href:!0});var Ns=r(he);pe=l(Ns,"FlauBERT"),Ns.forEach(s),ke=l(_,", "),xe=n(_,"A",{href:!0});var Ss=r(xe);qe=l(Ss,"FNet"),Ss.forEach(s),ne=l(_,", "),re=n(_,"A",{href:!0});var Ut=r(re);se=l(Ut,"Funnel Transformer"),Ut.forEach(s),me=l(_,", "),fe=n(_,"A",{href:!0});var Hs=r(fe);$e=l(Hs,"I-BERT"),Hs.forEach(s),u=l(_,", "),R=n(_,"A",{href:!0});var Ws=r(R);de=l(Ws,"LayoutLM"),Ws.forEach(s),ye=l(_,", "),g=n(_,"A",{href:!0});var vs=r(g);I=l(vs,"Longformer"),vs.forEach(s),je=l(_,", "),be=n(_,"A",{href:!0});var yt=r(be);Ee=l(yt,"LUKE"),yt.forEach(s),ee=l(_,", "),Ce=n(_,"A",{href:!0});var xs=r(Ce);ze=l(xs,"mBART"),xs.forEach(s),Se=l(_,", "),Te=n(_,"A",{href:!0});var Ft=r(Te);Pe=l(Ft,"Megatron-BERT"),Ft.forEach(s),Xe=l(_,", "),He=n(_,"A",{href:!0});var Ys=r(He);We=l(Ys,"MobileBERT"),Ys.forEach(s),Oe=l(_,", "),Be=n(_,"A",{href:!0});var Es=r(Be);Ye=l(Es,"MPNet"),Es.forEach(s),os=l(_,", "),Ze=n(_,"A",{href:!0});var it=r(Ze);et=l(it,"MVP"),it.forEach(s),It=l(_,", "),Re=n(_,"A",{href:!0});var Xt=r(Re);ns=l(Xt,"Nezha"),Xt.forEach(s),Tt=l(_,", "),mt=n(_,"A",{href:!0});var Us=r(mt);rs=l(Us,"Nystr\xF6mformer"),Us.forEach(s),At=l(_,", "),ft=n(_,"A",{href:!0});var Xs=r(ft);is=l(Xs,"Perceiver"),Xs.forEach(s),Ot=l(_,", "),Ie=n(_,"A",{href:!0});var bt=r(Ie);Ve=l(bt,"QDQBert"),bt.forEach(s),Mt=l(_,", "),Ne=n(_,"A",{href:!0});var Vs=r(Ne);ps=l(Vs,"Reformer"),Vs.forEach(s),qt=l(_,", "),ht=n(_,"A",{href:!0});var Vt=r(ht);Nt=l(Vt,"RemBERT"),Vt.forEach(s),tt=l(_,", "),st=n(_,"A",{href:!0});var Qs=r(st);Qe=l(Qs,"RoBERTa"),Qs.forEach(s),ms=l(_,", "),Ge=n(_,"A",{href:!0});var Gs=r(Ge);fs=l(Gs,"RoBERTa-PreLayerNorm"),Gs.forEach(s),hs=l(_,", "),at=n(_,"A",{href:!0});var Ts=r(at);lt=l(Ts,"RoCBert"),Ts.forEach(s),St=l(_,", "),_e=n(_,"A",{href:!0});var wt=r(_e);us=l(wt,"RoFormer"),wt.forEach(s),zt=l(_,", "),ut=n(_,"A",{href:!0});var As=r(ut);cs=l(As,"SqueezeBERT"),As.forEach(s),Pt=l(_,", "),ct=n(_,"A",{href:!0});var pt=r(ct);ds=l(pt,"TAPAS"),pt.forEach(s),Rt=l(_,", "),dt=n(_,"A",{href:!0});var Ks=r(dt);_s=l(Ks,"Wav2Vec2"),Ks.forEach(s),ot=l(_,", "),Ke=n(_,"A",{href:!0});var Qt=r(Ke);gs=l(Qt,"XLM"),Qt.forEach(s),ks=l(_,", "),nt=n(_,"A",{href:!0});var Js=r(nt);rt=l(Js,"XLM-RoBERTa"),Js.forEach(s),Ht=l(_,", "),Le=n(_,"A",{href:!0});var Zs=r(Le);$s=l(Zs,"XLM-RoBERTa-XL"),Zs.forEach(s),Lt=l(_,", "),_t=n(_,"A",{href:!0});var Ms=r(_t);ys=l(Ms,"X-MOD"),Ms.forEach(s),Dt=l(_,", "),gt=n(_,"A",{href:!0});var jt=r(gt);bs=l(jt,"YOSO"),jt.forEach(s),_.forEach(s),this.h()},h(){d(m,"href","../model_doc/albert"),d(v,"href","../model_doc/bart"),d(b,"href","../model_doc/bert"),d(F,"href","../model_doc/big_bird"),d(B,"href","../model_doc/camembert"),d(C,"href","../model_doc/convbert"),d(X,"href","../model_doc/data2vec-text"),d(N,"href","../model_doc/deberta"),d(Y,"href","../model_doc/deberta-v2"),d(K,"href","../model_doc/distilbert"),d(te,"href","../model_doc/electra"),d(we,"href","../model_doc/ernie"),d(J,"href","../model_doc/esm"),d(he,"href","../model_doc/flaubert"),d(xe,"href","../model_doc/fnet"),d(re,"href","../model_doc/funnel"),d(fe,"href","../model_doc/ibert"),d(R,"href","../model_doc/layoutlm"),d(g,"href","../model_doc/longformer"),d(be,"href","../model_doc/luke"),d(Ce,"href","../model_doc/mbart"),d(Te,"href","../model_doc/megatron-bert"),d(He,"href","../model_doc/mobilebert"),d(Be,"href","../model_doc/mpnet"),d(Ze,"href","../model_doc/mvp"),d(Re,"href","../model_doc/nezha"),d(mt,"href","../model_doc/nystromformer"),d(ft,"href","../model_doc/perceiver"),d(Ie,"href","../model_doc/qdqbert"),d(Ne,"href","../model_doc/reformer"),d(ht,"href","../model_doc/rembert"),d(st,"href","../model_doc/roberta"),d(Ge,"href","../model_doc/roberta-prelayernorm"),d(at,"href","../model_doc/roc_bert"),d(_e,"href","../model_doc/roformer"),d(ut,"href","../model_doc/squeezebert"),d(ct,"href","../model_doc/tapas"),d(dt,"href","../model_doc/wav2vec2"),d(Ke,"href","../model_doc/xlm"),d(nt,"href","../model_doc/xlm-roberta"),d(Le,"href","../model_doc/xlm-roberta-xl"),d(_t,"href","../model_doc/xmod"),d(gt,"href","../model_doc/yoso")},m(Ue,_){f(Ue,p,_),f(Ue,i,_),e(i,m),e(m,y),e(i,w),e(i,v),e(v,x),e(i,D),e(i,b),e(b,j),e(i,L),e(i,F),e(F,S),e(i,H),e(i,B),e(B,ie),e(i,G),e(i,C),e(C,le),e(i,U),e(i,X),e(X,O),e(i,W),e(i,N),e(N,c),e(i,E),e(i,Y),e(Y,ue),e(i,Z),e(i,K),e(K,oe),e(i,Fe),e(i,te),e(te,Ae),e(i,ce),e(i,we),e(we,ge),e(i,ve),e(i,J),e(J,Me),e(i,ae),e(i,he),e(he,pe),e(i,ke),e(i,xe),e(xe,qe),e(i,ne),e(i,re),e(re,se),e(i,me),e(i,fe),e(fe,$e),e(i,u),e(i,R),e(R,de),e(i,ye),e(i,g),e(g,I),e(i,je),e(i,be),e(be,Ee),e(i,ee),e(i,Ce),e(Ce,ze),e(i,Se),e(i,Te),e(Te,Pe),e(i,Xe),e(i,He),e(He,We),e(i,Oe),e(i,Be),e(Be,Ye),e(i,os),e(i,Ze),e(Ze,et),e(i,It),e(i,Re),e(Re,ns),e(i,Tt),e(i,mt),e(mt,rs),e(i,At),e(i,ft),e(ft,is),e(i,Ot),e(i,Ie),e(Ie,Ve),e(i,Mt),e(i,Ne),e(Ne,ps),e(i,qt),e(i,ht),e(ht,Nt),e(i,tt),e(i,st),e(st,Qe),e(i,ms),e(i,Ge),e(Ge,fs),e(i,hs),e(i,at),e(at,lt),e(i,St),e(i,_e),e(_e,us),e(i,zt),e(i,ut),e(ut,cs),e(i,Pt),e(i,ct),e(ct,ds),e(i,Rt),e(i,dt),e(dt,_s),e(i,ot),e(i,Ke),e(Ke,gs),e(i,ks),e(i,nt),e(nt,rt),e(i,Ht),e(i,Le),e(Le,$s),e(i,Lt),e(i,_t),e(_t,ys),e(i,Dt),e(i,gt),e(gt,bs)},d(Ue){Ue&&s(p),Ue&&s(i)}}}function go(V){let p,i,m,y,w,v,x,D;return x=new Q({props:{code:`from transformers import DataCollatorForLanguageModeling

tokenizer.pad_token = tokenizer.eos_token
data_collator = DataCollatorForLanguageModeling(tokenizer=tokenizer, mlm_probability=0.15)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DataCollatorForLanguageModeling

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.pad_token = tokenizer.eos_token
<span class="hljs-meta">&gt;&gt;&gt; </span>data_collator = DataCollatorForLanguageModeling(tokenizer=tokenizer, mlm_probability=<span class="hljs-number">0.15</span>)`}}),{c(){p=o("p"),i=a("Use the end-of-sequence token as the padding token and specify "),m=o("code"),y=a("mlm_probability"),w=a(" to randomly mask tokens each time you iterate over the data:"),v=k(),T(x.$$.fragment)},l(b){p=n(b,"P",{});var j=r(p);i=l(j,"Use the end-of-sequence token as the padding token and specify "),m=n(j,"CODE",{});var L=r(m);y=l(L,"mlm_probability"),L.forEach(s),w=l(j," to randomly mask tokens each time you iterate over the data:"),j.forEach(s),v=$(b),A(x.$$.fragment,b)},m(b,j){f(b,p,j),e(p,i),e(p,m),e(m,y),e(p,w),f(b,v,j),M(x,b,j),D=!0},p:Ya,i(b){D||(q(x.$$.fragment,b),D=!0)},o(b){z(x.$$.fragment,b),D=!1},d(b){b&&s(p),b&&s(v),P(x,b)}}}function ko(V){let p,i;return p=new ra({props:{$$slots:{default:[go]},$$scope:{ctx:V}}}),{c(){T(p.$$.fragment)},l(m){A(p.$$.fragment,m)},m(m,y){M(p,m,y),i=!0},p(m,y){const w={};y&2&&(w.$$scope={dirty:y,ctx:m}),p.$set(w)},i(m){i||(q(p.$$.fragment,m),i=!0)},o(m){z(p.$$.fragment,m),i=!1},d(m){P(p,m)}}}function $o(V){let p,i,m,y,w,v,x,D;return x=new Q({props:{code:`from transformers import DataCollatorForLanguageModeling

data_collator = DataCollatorForLanguageModeling(tokenizer=tokenizer, mlm_probability=0.15, return_tensors="tf")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DataCollatorForLanguageModeling

<span class="hljs-meta">&gt;&gt;&gt; </span>data_collator = DataCollatorForLanguageModeling(tokenizer=tokenizer, mlm_probability=<span class="hljs-number">0.15</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)`}}),{c(){p=o("p"),i=a("Use the end-of-sequence token as the padding token and specify "),m=o("code"),y=a("mlm_probability"),w=a(" to randomly mask tokens each time you iterate over the data:"),v=k(),T(x.$$.fragment)},l(b){p=n(b,"P",{});var j=r(p);i=l(j,"Use the end-of-sequence token as the padding token and specify "),m=n(j,"CODE",{});var L=r(m);y=l(L,"mlm_probability"),L.forEach(s),w=l(j," to randomly mask tokens each time you iterate over the data:"),j.forEach(s),v=$(b),A(x.$$.fragment,b)},m(b,j){f(b,p,j),e(p,i),e(p,m),e(m,y),e(p,w),f(b,v,j),M(x,b,j),D=!0},p:Ya,i(b){D||(q(x.$$.fragment,b),D=!0)},o(b){z(x.$$.fragment,b),D=!1},d(b){b&&s(p),b&&s(v),P(x,b)}}}function yo(V){let p,i;return p=new ra({props:{$$slots:{default:[$o]},$$scope:{ctx:V}}}),{c(){T(p.$$.fragment)},l(m){A(p.$$.fragment,m)},m(m,y){M(p,m,y),i=!0},p(m,y){const w={};y&2&&(w.$$scope={dirty:y,ctx:m}),p.$set(w)},i(m){i||(q(p.$$.fragment,m),i=!0)},o(m){z(p.$$.fragment,m),i=!1},d(m){P(p,m)}}}function bo(V){let p,i,m,y,w,v,x,D;return{c(){p=o("p"),i=a("If you aren\u2019t familiar with finetuning a model with the "),m=o("a"),y=a("Trainer"),w=a(", take a look at the basic tutorial "),v=o("a"),x=a("here"),D=a("!"),this.h()},l(b){p=n(b,"P",{});var j=r(p);i=l(j,"If you aren\u2019t familiar with finetuning a model with the "),m=n(j,"A",{href:!0});var L=r(m);y=l(L,"Trainer"),L.forEach(s),w=l(j,", take a look at the basic tutorial "),v=n(j,"A",{href:!0});var F=r(v);x=l(F,"here"),F.forEach(s),D=l(j,"!"),j.forEach(s),this.h()},h(){d(m,"href","/docs/transformers/main/en/main_classes/trainer#transformers.Trainer"),d(v,"href","../training#train-with-pytorch-trainer")},m(b,j){f(b,p,j),e(p,i),e(p,m),e(m,y),e(p,w),e(p,v),e(v,x),e(p,D)},d(b){b&&s(p)}}}function wo(V){let p,i,m,y,w,v,x,D,b,j,L,F,S,H,B,ie,G,C,le,U,X,O,W,N,c,E,Y,ue,Z,K,oe,Fe,te,Ae,ce,we,ge,ve,J,Me,ae,he,pe,ke,xe,qe,ne,re,se,me,fe,$e,u,R,de,ye;return p=new Wa({props:{$$slots:{default:[bo]},$$scope:{ctx:V}}}),b=new Q({props:{code:`from transformers import AutoModelForMaskedLM

model = AutoModelForMaskedLM.from_pretrained("distilroberta-base")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForMaskedLM

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForMaskedLM.from_pretrained(<span class="hljs-string">&quot;distilroberta-base&quot;</span>)`}}),J=new Q({props:{code:`training_args = TrainingArguments(
    output_dir="my_awesome_eli5_mlm_model",
    evaluation_strategy="epoch",
    learning_rate=2e-5,
    num_train_epochs=3,
    weight_decay=0.01,
    push_to_hub=True,
)

trainer = Trainer(
    model=model,
    args=training_args,
    train_dataset=lm_dataset["train"],
    eval_dataset=lm_dataset["test"],
    data_collator=data_collator,
)

trainer.train()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>training_args = TrainingArguments(
<span class="hljs-meta">... </span>    output_dir=<span class="hljs-string">&quot;my_awesome_eli5_mlm_model&quot;</span>,
<span class="hljs-meta">... </span>    evaluation_strategy=<span class="hljs-string">&quot;epoch&quot;</span>,
<span class="hljs-meta">... </span>    learning_rate=<span class="hljs-number">2e-5</span>,
<span class="hljs-meta">... </span>    num_train_epochs=<span class="hljs-number">3</span>,
<span class="hljs-meta">... </span>    weight_decay=<span class="hljs-number">0.01</span>,
<span class="hljs-meta">... </span>    push_to_hub=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>trainer = Trainer(
<span class="hljs-meta">... </span>    model=model,
<span class="hljs-meta">... </span>    args=training_args,
<span class="hljs-meta">... </span>    train_dataset=lm_dataset[<span class="hljs-string">&quot;train&quot;</span>],
<span class="hljs-meta">... </span>    eval_dataset=lm_dataset[<span class="hljs-string">&quot;test&quot;</span>],
<span class="hljs-meta">... </span>    data_collator=data_collator,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>trainer.train()`}}),ne=new Q({props:{code:`import math

eval_results = trainer.evaluate()
print(f"Perplexity: {math.exp(eval_results['eval_loss']):.2f}")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> math

<span class="hljs-meta">&gt;&gt;&gt; </span>eval_results = trainer.evaluate()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Perplexity: <span class="hljs-subst">{math.exp(eval_results[<span class="hljs-string">&#x27;eval_loss&#x27;</span>]):<span class="hljs-number">.2</span>f}</span>&quot;</span>)
Perplexity: <span class="hljs-number">8.76</span>`}}),de=new Q({props:{code:"trainer.push_to_hub()",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>trainer.push_to_hub()'}}),{c(){T(p.$$.fragment),i=k(),m=o("p"),y=a("You\u2019re ready to start training your model now! Load DistilRoBERTa with "),w=o("a"),v=a("AutoModelForMaskedLM"),x=a(":"),D=k(),T(b.$$.fragment),j=k(),L=o("p"),F=a("At this point, only three steps remain:"),S=k(),H=o("ol"),B=o("li"),ie=a("Define your training hyperparameters in "),G=o("a"),C=a("TrainingArguments"),le=a(". The only required parameter is "),U=o("code"),X=a("output_dir"),O=a(" which specifies where to save your model. You\u2019ll push this model to the Hub by setting "),W=o("code"),N=a("push_to_hub=True"),c=a(" (you need to be signed in to Hugging Face to upload your model)."),E=k(),Y=o("li"),ue=a("Pass the training arguments to "),Z=o("a"),K=a("Trainer"),oe=a(" along with the model, datasets, and data collator."),Fe=k(),te=o("li"),Ae=a("Call "),ce=o("a"),we=a("train()"),ge=a(" to finetune your model."),ve=k(),T(J.$$.fragment),Me=k(),ae=o("p"),he=a("Once training is completed, use the "),pe=o("a"),ke=a("evaluate()"),xe=a(" method to evaluate your model and get its perplexity:"),qe=k(),T(ne.$$.fragment),re=k(),se=o("p"),me=a("Then share your model to the Hub with the "),fe=o("a"),$e=a("push_to_hub()"),u=a(" method so everyone can use your model:"),R=k(),T(de.$$.fragment),this.h()},l(g){A(p.$$.fragment,g),i=$(g),m=n(g,"P",{});var I=r(m);y=l(I,"You\u2019re ready to start training your model now! Load DistilRoBERTa with "),w=n(I,"A",{href:!0});var je=r(w);v=l(je,"AutoModelForMaskedLM"),je.forEach(s),x=l(I,":"),I.forEach(s),D=$(g),A(b.$$.fragment,g),j=$(g),L=n(g,"P",{});var be=r(L);F=l(be,"At this point, only three steps remain:"),be.forEach(s),S=$(g),H=n(g,"OL",{});var Ee=r(H);B=n(Ee,"LI",{});var ee=r(B);ie=l(ee,"Define your training hyperparameters in "),G=n(ee,"A",{href:!0});var Ce=r(G);C=l(Ce,"TrainingArguments"),Ce.forEach(s),le=l(ee,". The only required parameter is "),U=n(ee,"CODE",{});var ze=r(U);X=l(ze,"output_dir"),ze.forEach(s),O=l(ee," which specifies where to save your model. You\u2019ll push this model to the Hub by setting "),W=n(ee,"CODE",{});var Se=r(W);N=l(Se,"push_to_hub=True"),Se.forEach(s),c=l(ee," (you need to be signed in to Hugging Face to upload your model)."),ee.forEach(s),E=$(Ee),Y=n(Ee,"LI",{});var Te=r(Y);ue=l(Te,"Pass the training arguments to "),Z=n(Te,"A",{href:!0});var Pe=r(Z);K=l(Pe,"Trainer"),Pe.forEach(s),oe=l(Te," along with the model, datasets, and data collator."),Te.forEach(s),Fe=$(Ee),te=n(Ee,"LI",{});var Xe=r(te);Ae=l(Xe,"Call "),ce=n(Xe,"A",{href:!0});var He=r(ce);we=l(He,"train()"),He.forEach(s),ge=l(Xe," to finetune your model."),Xe.forEach(s),Ee.forEach(s),ve=$(g),A(J.$$.fragment,g),Me=$(g),ae=n(g,"P",{});var We=r(ae);he=l(We,"Once training is completed, use the "),pe=n(We,"A",{href:!0});var Oe=r(pe);ke=l(Oe,"evaluate()"),Oe.forEach(s),xe=l(We," method to evaluate your model and get its perplexity:"),We.forEach(s),qe=$(g),A(ne.$$.fragment,g),re=$(g),se=n(g,"P",{});var Be=r(se);me=l(Be,"Then share your model to the Hub with the "),fe=n(Be,"A",{href:!0});var Ye=r(fe);$e=l(Ye,"push_to_hub()"),Ye.forEach(s),u=l(Be," method so everyone can use your model:"),Be.forEach(s),R=$(g),A(de.$$.fragment,g),this.h()},h(){d(w,"href","/docs/transformers/main/en/model_doc/auto#transformers.AutoModelForMaskedLM"),d(G,"href","/docs/transformers/main/en/main_classes/trainer#transformers.TrainingArguments"),d(Z,"href","/docs/transformers/main/en/main_classes/trainer#transformers.Trainer"),d(ce,"href","/docs/transformers/main/en/main_classes/trainer#transformers.Trainer.train"),d(pe,"href","/docs/transformers/main/en/main_classes/trainer#transformers.Trainer.evaluate"),d(fe,"href","/docs/transformers/main/en/main_classes/trainer#transformers.Trainer.push_to_hub")},m(g,I){M(p,g,I),f(g,i,I),f(g,m,I),e(m,y),e(m,w),e(w,v),e(m,x),f(g,D,I),M(b,g,I),f(g,j,I),f(g,L,I),e(L,F),f(g,S,I),f(g,H,I),e(H,B),e(B,ie),e(B,G),e(G,C),e(B,le),e(B,U),e(U,X),e(B,O),e(B,W),e(W,N),e(B,c),e(H,E),e(H,Y),e(Y,ue),e(Y,Z),e(Z,K),e(Y,oe),e(H,Fe),e(H,te),e(te,Ae),e(te,ce),e(ce,we),e(te,ge),f(g,ve,I),M(J,g,I),f(g,Me,I),f(g,ae,I),e(ae,he),e(ae,pe),e(pe,ke),e(ae,xe),f(g,qe,I),M(ne,g,I),f(g,re,I),f(g,se,I),e(se,me),e(se,fe),e(fe,$e),e(se,u),f(g,R,I),M(de,g,I),ye=!0},p(g,I){const je={};I&2&&(je.$$scope={dirty:I,ctx:g}),p.$set(je)},i(g){ye||(q(p.$$.fragment,g),q(b.$$.fragment,g),q(J.$$.fragment,g),q(ne.$$.fragment,g),q(de.$$.fragment,g),ye=!0)},o(g){z(p.$$.fragment,g),z(b.$$.fragment,g),z(J.$$.fragment,g),z(ne.$$.fragment,g),z(de.$$.fragment,g),ye=!1},d(g){P(p,g),g&&s(i),g&&s(m),g&&s(D),P(b,g),g&&s(j),g&&s(L),g&&s(S),g&&s(H),g&&s(ve),P(J,g),g&&s(Me),g&&s(ae),g&&s(qe),P(ne,g),g&&s(re),g&&s(se),g&&s(R),P(de,g)}}}function jo(V){let p,i;return p=new ra({props:{$$slots:{default:[wo]},$$scope:{ctx:V}}}),{c(){T(p.$$.fragment)},l(m){A(p.$$.fragment,m)},m(m,y){M(p,m,y),i=!0},p(m,y){const w={};y&2&&(w.$$scope={dirty:y,ctx:m}),p.$set(w)},i(m){i||(q(p.$$.fragment,m),i=!0)},o(m){z(p.$$.fragment,m),i=!1},d(m){P(p,m)}}}function vo(V){let p,i,m,y,w;return{c(){p=o("p"),i=a("If you aren\u2019t familiar with finetuning a model with Keras, take a look at the basic tutorial "),m=o("a"),y=a("here"),w=a("!"),this.h()},l(v){p=n(v,"P",{});var x=r(p);i=l(x,"If you aren\u2019t familiar with finetuning a model with Keras, take a look at the basic tutorial "),m=n(x,"A",{href:!0});var D=r(m);y=l(D,"here"),D.forEach(s),w=l(x,"!"),x.forEach(s),this.h()},h(){d(m,"href","../training#train-a-tensorflow-model-with-keras")},m(v,x){f(v,p,x),e(p,i),e(p,m),e(m,y),e(p,w)},d(v){v&&s(p)}}}function xo(V){let p,i,m,y,w,v,x,D,b,j,L,F,S,H,B,ie,G,C,le,U,X,O,W,N,c,E,Y,ue,Z,K,oe,Fe,te,Ae,ce,we,ge,ve,J,Me,ae,he,pe,ke,xe,qe,ne,re,se,me,fe,$e;return p=new Wa({props:{$$slots:{default:[vo]},$$scope:{ctx:V}}}),m=new Q({props:{code:`from transformers import create_optimizer, AdamWeightDecay

optimizer = AdamWeightDecay(learning_rate=2e-5, weight_decay_rate=0.01)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> create_optimizer, AdamWeightDecay

<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = AdamWeightDecay(learning_rate=<span class="hljs-number">2e-5</span>, weight_decay_rate=<span class="hljs-number">0.01</span>)`}}),L=new Q({props:{code:`from transformers import TFAutoModelForMaskedLM

model = TFAutoModelForMaskedLM.from_pretrained("distilroberta-base")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TFAutoModelForMaskedLM

<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFAutoModelForMaskedLM.from_pretrained(<span class="hljs-string">&quot;distilroberta-base&quot;</span>)`}}),O=new Q({props:{code:`tf_train_set = model.prepare_tf_dataset(
    lm_dataset["train"],
    shuffle=True,
    batch_size=16,
    collate_fn=data_collator,
)

tf_test_set = model.prepare_tf_dataset(
    lm_dataset["test"],
    shuffle=False,
    batch_size=16,
    collate_fn=data_collator,
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>tf_train_set = model.prepare_tf_dataset(
<span class="hljs-meta">... </span>    lm_dataset[<span class="hljs-string">&quot;train&quot;</span>],
<span class="hljs-meta">... </span>    shuffle=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    batch_size=<span class="hljs-number">16</span>,
<span class="hljs-meta">... </span>    collate_fn=data_collator,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>tf_test_set = model.prepare_tf_dataset(
<span class="hljs-meta">... </span>    lm_dataset[<span class="hljs-string">&quot;test&quot;</span>],
<span class="hljs-meta">... </span>    shuffle=<span class="hljs-literal">False</span>,
<span class="hljs-meta">... </span>    batch_size=<span class="hljs-number">16</span>,
<span class="hljs-meta">... </span>    collate_fn=data_collator,
<span class="hljs-meta">... </span>)`}}),oe=new Q({props:{code:`import tensorflow as tf

model.compile(optimizer=optimizer)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>model.<span class="hljs-built_in">compile</span>(optimizer=optimizer)`}}),J=new Q({props:{code:`from transformers.keras_callbacks import PushToHubCallback

callback = PushToHubCallback(
    output_dir="my_awesome_eli5_mlm_model",
    tokenizer=tokenizer,
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers.keras_callbacks <span class="hljs-keyword">import</span> PushToHubCallback

<span class="hljs-meta">&gt;&gt;&gt; </span>callback = PushToHubCallback(
<span class="hljs-meta">... </span>    output_dir=<span class="hljs-string">&quot;my_awesome_eli5_mlm_model&quot;</span>,
<span class="hljs-meta">... </span>    tokenizer=tokenizer,
<span class="hljs-meta">... </span>)`}}),re=new Q({props:{code:"model.fit(x=tf_train_set, validation_data=tf_test_set, epochs=3, callbacks=[callback])",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>model.fit(x=tf_train_set, validation_data=tf_test_set, epochs=<span class="hljs-number">3</span>, callbacks=[callback])'}}),{c(){T(p.$$.fragment),i=a(`
To finetune a model in TensorFlow, start by setting up an optimizer function, learning rate schedule, and some training hyperparameters:

	`),T(m.$$.fragment),y=k(),w=o("p"),v=a("Then you can load DistilRoBERTa with "),x=o("a"),D=a("TFAutoModelForMaskedLM"),b=a(":"),j=k(),T(L.$$.fragment),F=k(),S=o("p"),H=a("Convert your datasets to the "),B=o("code"),ie=a("tf.data.Dataset"),G=a(" format with "),C=o("a"),le=a("prepare_tf_dataset()"),U=a(":"),X=k(),T(O.$$.fragment),W=k(),N=o("p"),c=a("Configure the model for training with "),E=o("a"),Y=o("code"),ue=a("compile"),Z=a(":"),K=k(),T(oe.$$.fragment),Fe=k(),te=o("p"),Ae=a("This can be done by specifying where to push your model and tokenizer in the "),ce=o("a"),we=a("PushToHubCallback"),ge=a(":"),ve=k(),T(J.$$.fragment),Me=k(),ae=o("p"),he=a("Finally, you\u2019re ready to start training your model! Call "),pe=o("a"),ke=o("code"),xe=a("fit"),qe=a(" with your training and validation datasets, the number of epochs, and your callback to finetune the model:"),ne=k(),T(re.$$.fragment),se=k(),me=o("p"),fe=a("Once training is completed, your model is automatically uploaded to the Hub so everyone can use it!"),this.h()},l(u){A(p.$$.fragment,u),i=l(u,`
To finetune a model in TensorFlow, start by setting up an optimizer function, learning rate schedule, and some training hyperparameters:

	`),A(m.$$.fragment,u),y=$(u),w=n(u,"P",{});var R=r(w);v=l(R,"Then you can load DistilRoBERTa with "),x=n(R,"A",{href:!0});var de=r(x);D=l(de,"TFAutoModelForMaskedLM"),de.forEach(s),b=l(R,":"),R.forEach(s),j=$(u),A(L.$$.fragment,u),F=$(u),S=n(u,"P",{});var ye=r(S);H=l(ye,"Convert your datasets to the "),B=n(ye,"CODE",{});var g=r(B);ie=l(g,"tf.data.Dataset"),g.forEach(s),G=l(ye," format with "),C=n(ye,"A",{href:!0});var I=r(C);le=l(I,"prepare_tf_dataset()"),I.forEach(s),U=l(ye,":"),ye.forEach(s),X=$(u),A(O.$$.fragment,u),W=$(u),N=n(u,"P",{});var je=r(N);c=l(je,"Configure the model for training with "),E=n(je,"A",{href:!0,rel:!0});var be=r(E);Y=n(be,"CODE",{});var Ee=r(Y);ue=l(Ee,"compile"),Ee.forEach(s),be.forEach(s),Z=l(je,":"),je.forEach(s),K=$(u),A(oe.$$.fragment,u),Fe=$(u),te=n(u,"P",{});var ee=r(te);Ae=l(ee,"This can be done by specifying where to push your model and tokenizer in the "),ce=n(ee,"A",{href:!0});var Ce=r(ce);we=l(Ce,"PushToHubCallback"),Ce.forEach(s),ge=l(ee,":"),ee.forEach(s),ve=$(u),A(J.$$.fragment,u),Me=$(u),ae=n(u,"P",{});var ze=r(ae);he=l(ze,"Finally, you\u2019re ready to start training your model! Call "),pe=n(ze,"A",{href:!0,rel:!0});var Se=r(pe);ke=n(Se,"CODE",{});var Te=r(ke);xe=l(Te,"fit"),Te.forEach(s),Se.forEach(s),qe=l(ze," with your training and validation datasets, the number of epochs, and your callback to finetune the model:"),ze.forEach(s),ne=$(u),A(re.$$.fragment,u),se=$(u),me=n(u,"P",{});var Pe=r(me);fe=l(Pe,"Once training is completed, your model is automatically uploaded to the Hub so everyone can use it!"),Pe.forEach(s),this.h()},h(){d(x,"href","/docs/transformers/main/en/model_doc/auto#transformers.TFAutoModelForMaskedLM"),d(C,"href","/docs/transformers/main/en/main_classes/model#transformers.TFPreTrainedModel.prepare_tf_dataset"),d(E,"href","https://keras.io/api/models/model_training_apis/#compile-method"),d(E,"rel","nofollow"),d(ce,"href","/docs/transformers/main/en/main_classes/keras_callbacks#transformers.PushToHubCallback"),d(pe,"href","https://keras.io/api/models/model_training_apis/#fit-method"),d(pe,"rel","nofollow")},m(u,R){M(p,u,R),f(u,i,R),M(m,u,R),f(u,y,R),f(u,w,R),e(w,v),e(w,x),e(x,D),e(w,b),f(u,j,R),M(L,u,R),f(u,F,R),f(u,S,R),e(S,H),e(S,B),e(B,ie),e(S,G),e(S,C),e(C,le),e(S,U),f(u,X,R),M(O,u,R),f(u,W,R),f(u,N,R),e(N,c),e(N,E),e(E,Y),e(Y,ue),e(N,Z),f(u,K,R),M(oe,u,R),f(u,Fe,R),f(u,te,R),e(te,Ae),e(te,ce),e(ce,we),e(te,ge),f(u,ve,R),M(J,u,R),f(u,Me,R),f(u,ae,R),e(ae,he),e(ae,pe),e(pe,ke),e(ke,xe),e(ae,qe),f(u,ne,R),M(re,u,R),f(u,se,R),f(u,me,R),e(me,fe),$e=!0},p(u,R){const de={};R&2&&(de.$$scope={dirty:R,ctx:u}),p.$set(de)},i(u){$e||(q(p.$$.fragment,u),q(m.$$.fragment,u),q(L.$$.fragment,u),q(O.$$.fragment,u),q(oe.$$.fragment,u),q(J.$$.fragment,u),q(re.$$.fragment,u),$e=!0)},o(u){z(p.$$.fragment,u),z(m.$$.fragment,u),z(L.$$.fragment,u),z(O.$$.fragment,u),z(oe.$$.fragment,u),z(J.$$.fragment,u),z(re.$$.fragment,u),$e=!1},d(u){P(p,u),u&&s(i),P(m,u),u&&s(y),u&&s(w),u&&s(j),P(L,u),u&&s(F),u&&s(S),u&&s(X),P(O,u),u&&s(W),u&&s(N),u&&s(K),P(oe,u),u&&s(Fe),u&&s(te),u&&s(ve),P(J,u),u&&s(Me),u&&s(ae),u&&s(ne),P(re,u),u&&s(se),u&&s(me)}}}function Eo(V){let p,i;return p=new ra({props:{$$slots:{default:[xo]},$$scope:{ctx:V}}}),{c(){T(p.$$.fragment)},l(m){A(p.$$.fragment,m)},m(m,y){M(p,m,y),i=!0},p(m,y){const w={};y&2&&(w.$$scope={dirty:y,ctx:m}),p.$set(w)},i(m){i||(q(p.$$.fragment,m),i=!0)},o(m){z(p.$$.fragment,m),i=!1},d(m){P(p,m)}}}function To(V){let p,i,m,y,w,v,x,D;return{c(){p=o("p"),i=a(`For a more in-depth example of how to finetune a model for masked language modeling, take a look at the corresponding
`),m=o("a"),y=a("PyTorch notebook"),w=a(`
or `),v=o("a"),x=a("TensorFlow notebook"),D=a("."),this.h()},l(b){p=n(b,"P",{});var j=r(p);i=l(j,`For a more in-depth example of how to finetune a model for masked language modeling, take a look at the corresponding
`),m=n(j,"A",{href:!0,rel:!0});var L=r(m);y=l(L,"PyTorch notebook"),L.forEach(s),w=l(j,`
or `),v=n(j,"A",{href:!0,rel:!0});var F=r(v);x=l(F,"TensorFlow notebook"),F.forEach(s),D=l(j,"."),j.forEach(s),this.h()},h(){d(m,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/language_modeling.ipynb"),d(m,"rel","nofollow"),d(v,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/language_modeling-tf.ipynb"),d(v,"rel","nofollow")},m(b,j){f(b,p,j),e(p,i),e(p,m),e(m,y),e(p,w),e(p,v),e(v,x),e(p,D)},d(b){b&&s(p)}}}function Ao(V){let p,i,m,y,w,v,x,D,b,j,L,F,S,H,B,ie,G,C,le,U,X,O,W,N;return j=new Q({props:{code:`from transformers import AutoTokenizer

tokenizer = AutoTokenizer.from_pretrained("my_awesome_eli5_mlm_model")
inputs = tokenizer(text, return_tensors="pt")
mask_token_index = torch.where(inputs["input_ids"] == tokenizer.mask_token_id)[1]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;my_awesome_eli5_mlm_model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(text, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_token_index = torch.where(inputs[<span class="hljs-string">&quot;input_ids&quot;</span>] == tokenizer.mask_token_id)[<span class="hljs-number">1</span>]`}}),C=new Q({props:{code:`from transformers import AutoModelForMaskedLM

model = AutoModelForMaskedLM.from_pretrained("stevhliu/my_awesome_eli5_mlm_model")
logits = model(**inputs).logits
mask_token_logits = logits[0, mask_token_index, :]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForMaskedLM

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForMaskedLM.from_pretrained(<span class="hljs-string">&quot;stevhliu/my_awesome_eli5_mlm_model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(**inputs).logits
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_token_logits = logits[<span class="hljs-number">0</span>, mask_token_index, :]`}}),W=new Q({props:{code:`top_3_tokens = torch.topk(mask_token_logits, 3, dim=1).indices[0].tolist()

for token in top_3_tokens:
    print(text.replace(tokenizer.mask_token, tokenizer.decode([token])))`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>top_3_tokens = torch.topk(mask_token_logits, <span class="hljs-number">3</span>, dim=<span class="hljs-number">1</span>).indices[<span class="hljs-number">0</span>].tolist()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> token <span class="hljs-keyword">in</span> top_3_tokens:
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(text.replace(tokenizer.mask_token, tokenizer.decode([token])))
The Milky Way <span class="hljs-keyword">is</span> a spiral galaxy.
The Milky Way <span class="hljs-keyword">is</span> a massive galaxy.
The Milky Way <span class="hljs-keyword">is</span> a small galaxy.`}}),{c(){p=o("p"),i=a("Tokenize the text and return the "),m=o("code"),y=a("input_ids"),w=a(" as PyTorch tensors. You\u2019ll also need to specify the position of the "),v=o("code"),x=a("<mask>"),D=a(" token:"),b=k(),T(j.$$.fragment),L=k(),F=o("p"),S=a("Pass your inputs to the model and return the "),H=o("code"),B=a("logits"),ie=a(" of the masked token:"),G=k(),T(C.$$.fragment),le=k(),U=o("p"),X=a("Then return the three masked tokens with the highest probability and print them out:"),O=k(),T(W.$$.fragment)},l(c){p=n(c,"P",{});var E=r(p);i=l(E,"Tokenize the text and return the "),m=n(E,"CODE",{});var Y=r(m);y=l(Y,"input_ids"),Y.forEach(s),w=l(E," as PyTorch tensors. You\u2019ll also need to specify the position of the "),v=n(E,"CODE",{});var ue=r(v);x=l(ue,"<mask>"),ue.forEach(s),D=l(E," token:"),E.forEach(s),b=$(c),A(j.$$.fragment,c),L=$(c),F=n(c,"P",{});var Z=r(F);S=l(Z,"Pass your inputs to the model and return the "),H=n(Z,"CODE",{});var K=r(H);B=l(K,"logits"),K.forEach(s),ie=l(Z," of the masked token:"),Z.forEach(s),G=$(c),A(C.$$.fragment,c),le=$(c),U=n(c,"P",{});var oe=r(U);X=l(oe,"Then return the three masked tokens with the highest probability and print them out:"),oe.forEach(s),O=$(c),A(W.$$.fragment,c)},m(c,E){f(c,p,E),e(p,i),e(p,m),e(m,y),e(p,w),e(p,v),e(v,x),e(p,D),f(c,b,E),M(j,c,E),f(c,L,E),f(c,F,E),e(F,S),e(F,H),e(H,B),e(F,ie),f(c,G,E),M(C,c,E),f(c,le,E),f(c,U,E),e(U,X),f(c,O,E),M(W,c,E),N=!0},p:Ya,i(c){N||(q(j.$$.fragment,c),q(C.$$.fragment,c),q(W.$$.fragment,c),N=!0)},o(c){z(j.$$.fragment,c),z(C.$$.fragment,c),z(W.$$.fragment,c),N=!1},d(c){c&&s(p),c&&s(b),P(j,c),c&&s(L),c&&s(F),c&&s(G),P(C,c),c&&s(le),c&&s(U),c&&s(O),P(W,c)}}}function Mo(V){let p,i;return p=new ra({props:{$$slots:{default:[Ao]},$$scope:{ctx:V}}}),{c(){T(p.$$.fragment)},l(m){A(p.$$.fragment,m)},m(m,y){M(p,m,y),i=!0},p(m,y){const w={};y&2&&(w.$$scope={dirty:y,ctx:m}),p.$set(w)},i(m){i||(q(p.$$.fragment,m),i=!0)},o(m){z(p.$$.fragment,m),i=!1},d(m){P(p,m)}}}function qo(V){let p,i,m,y,w,v,x,D,b,j,L,F,S,H,B,ie,G,C,le,U,X,O,W,N;return j=new Q({props:{code:`from transformers import AutoTokenizer

tokenizer = AutoTokenizer.from_pretrained("my_awesome_eli5_mlm_model")
inputs = tokenizer(text, return_tensors="tf")
mask_token_index = tf.where(inputs["input_ids"] == tokenizer.mask_token_id)[0, 1]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;my_awesome_eli5_mlm_model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(text, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_token_index = tf.where(inputs[<span class="hljs-string">&quot;input_ids&quot;</span>] == tokenizer.mask_token_id)[<span class="hljs-number">0</span>, <span class="hljs-number">1</span>]`}}),C=new Q({props:{code:`from transformers import TFAutoModelForMaskedLM

model = TFAutoModelForMaskedLM.from_pretrained("stevhliu/my_awesome_eli5_mlm_model")
logits = model(**inputs).logits
mask_token_logits = logits[0, mask_token_index, :]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TFAutoModelForMaskedLM

<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFAutoModelForMaskedLM.from_pretrained(<span class="hljs-string">&quot;stevhliu/my_awesome_eli5_mlm_model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(**inputs).logits
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_token_logits = logits[<span class="hljs-number">0</span>, mask_token_index, :]`}}),W=new Q({props:{code:`top_3_tokens = tf.math.top_k(mask_token_logits, 3).indices.numpy()

for token in top_3_tokens:
    print(text.replace(tokenizer.mask_token, tokenizer.decode([token])))`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>top_3_tokens = tf.math.top_k(mask_token_logits, <span class="hljs-number">3</span>).indices.numpy()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> token <span class="hljs-keyword">in</span> top_3_tokens:
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(text.replace(tokenizer.mask_token, tokenizer.decode([token])))
The Milky Way <span class="hljs-keyword">is</span> a spiral galaxy.
The Milky Way <span class="hljs-keyword">is</span> a massive galaxy.
The Milky Way <span class="hljs-keyword">is</span> a small galaxy.`}}),{c(){p=o("p"),i=a("Tokenize the text and return the "),m=o("code"),y=a("input_ids"),w=a(" as TensorFlow tensors. You\u2019ll also need to specify the position of the "),v=o("code"),x=a("<mask>"),D=a(" token:"),b=k(),T(j.$$.fragment),L=k(),F=o("p"),S=a("Pass your inputs to the model and return the "),H=o("code"),B=a("logits"),ie=a(" of the masked token:"),G=k(),T(C.$$.fragment),le=k(),U=o("p"),X=a("Then return the three masked tokens with the highest probability and print them out:"),O=k(),T(W.$$.fragment)},l(c){p=n(c,"P",{});var E=r(p);i=l(E,"Tokenize the text and return the "),m=n(E,"CODE",{});var Y=r(m);y=l(Y,"input_ids"),Y.forEach(s),w=l(E," as TensorFlow tensors. You\u2019ll also need to specify the position of the "),v=n(E,"CODE",{});var ue=r(v);x=l(ue,"<mask>"),ue.forEach(s),D=l(E," token:"),E.forEach(s),b=$(c),A(j.$$.fragment,c),L=$(c),F=n(c,"P",{});var Z=r(F);S=l(Z,"Pass your inputs to the model and return the "),H=n(Z,"CODE",{});var K=r(H);B=l(K,"logits"),K.forEach(s),ie=l(Z," of the masked token:"),Z.forEach(s),G=$(c),A(C.$$.fragment,c),le=$(c),U=n(c,"P",{});var oe=r(U);X=l(oe,"Then return the three masked tokens with the highest probability and print them out:"),oe.forEach(s),O=$(c),A(W.$$.fragment,c)},m(c,E){f(c,p,E),e(p,i),e(p,m),e(m,y),e(p,w),e(p,v),e(v,x),e(p,D),f(c,b,E),M(j,c,E),f(c,L,E),f(c,F,E),e(F,S),e(F,H),e(H,B),e(F,ie),f(c,G,E),M(C,c,E),f(c,le,E),f(c,U,E),e(U,X),f(c,O,E),M(W,c,E),N=!0},p:Ya,i(c){N||(q(j.$$.fragment,c),q(C.$$.fragment,c),q(W.$$.fragment,c),N=!0)},o(c){z(j.$$.fragment,c),z(C.$$.fragment,c),z(W.$$.fragment,c),N=!1},d(c){c&&s(p),c&&s(b),P(j,c),c&&s(L),c&&s(F),c&&s(G),P(C,c),c&&s(le),c&&s(U),c&&s(O),P(W,c)}}}function zo(V){let p,i;return p=new ra({props:{$$slots:{default:[qo]},$$scope:{ctx:V}}}),{c(){T(p.$$.fragment)},l(m){A(p.$$.fragment,m)},m(m,y){M(p,m,y),i=!0},p(m,y){const w={};y&2&&(w.$$scope={dirty:y,ctx:m}),p.$set(w)},i(m){i||(q(p.$$.fragment,m),i=!0)},o(m){z(p.$$.fragment,m),i=!1},d(m){P(p,m)}}}function Po(V){let p,i,m,y,w,v,x,D,b,j,L,F,S,H,B,ie,G,C,le,U,X,O,W,N,c,E,Y,ue,Z,K,oe,Fe,te,Ae,ce,we,ge,ve,J,Me,ae,he,pe,ke,xe,qe,ne,re,se,me,fe,$e,u,R,de,ye,g,I,je,be,Ee,ee,Ce,ze,Se,Te,Pe,Xe,He,We,Oe,Be,Ye,os,Ze,et,It,Re,ns,Tt,mt,rs,At,ft,is,Ot,Ie,Ve,Mt,Ne,ps,qt,ht,Nt,tt,st,Qe,ms,Ge,fs,hs,at,lt,St,_e,us,zt,ut,cs,Pt,ct,ds,Rt,dt,_s,ot,Ke,gs,ks,nt,rt,Ht,Le,$s,Lt,_t,ys,Dt,gt,bs,Ue,_,Ds,ws,kt,js,De,Fs,$t,Cs,Bs,Wt,Is,Os,Yt,Ns,Ss,Ut,Hs,Ws,vs,yt,xs,Ft,Ys,Es,it,Xt,Us,Xs,bt,Vs,Vt,Qs,Gs,Ts,wt,As,pt,Ks,Qt,Js,Zs,Ms,jt,ba,vt,Ua,ea,Xa,Va,ia,Qa,Ga,wa,Gt,ja,Ct,Kt,pa,qs,Ka,ma,Ja,va,Jt,xa,Zt,Ea,Bt,es,fa,zs,Za,ha,el,Ta,ta,tl,Aa,ts,sl,ua,al,ll,Ma,Ps,qa,Je,ol,sa,nl,rl,ca,il,pl,da,ml,fl,za,Rs,Pa,ss,Ra;return v=new ya({}),L=new co({props:{classNames:"absolute z-10 right-0 top-0",options:[{label:"Mixed",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/transformers_doc/en/masked_language_modeling.ipynb"},{label:"PyTorch",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/transformers_doc/en/pytorch/masked_language_modeling.ipynb"},{label:"TensorFlow",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/transformers_doc/en/tensorflow/masked_language_modeling.ipynb"},{label:"Mixed",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/transformers_doc/en/masked_language_modeling.ipynb"},{label:"PyTorch",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/transformers_doc/en/pytorch/masked_language_modeling.ipynb"},{label:"TensorFlow",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/transformers_doc/en/tensorflow/masked_language_modeling.ipynb"}]}}),S=new io({props:{id:"mqElG5QJWUg"}}),ge=new Wa({props:{$$slots:{default:[_o]},$$scope:{ctx:V}}}),he=new Q({props:{code:"pip install transformers datasets evaluate",highlighted:"pip install transformers datasets evaluate"}}),ne=new Q({props:{code:`from huggingface_hub import notebook_login

notebook_login()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> notebook_login

<span class="hljs-meta">&gt;&gt;&gt; </span>notebook_login()`}}),$e=new ya({}),be=new Q({props:{code:`from datasets import load_dataset

eli5 = load_dataset("eli5", split="train_asks[:5000]")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset

<span class="hljs-meta">&gt;&gt;&gt; </span>eli5 = load_dataset(<span class="hljs-string">&quot;eli5&quot;</span>, split=<span class="hljs-string">&quot;train_asks[:5000]&quot;</span>)`}}),Oe=new Q({props:{code:"eli5 = eli5.train_test_split(test_size=0.2)",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>eli5 = eli5.train_test_split(test_size=<span class="hljs-number">0.2</span>)'}}),et=new Q({props:{code:'eli5["train"][0]',highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>eli5[<span class="hljs-string">&quot;train&quot;</span>][<span class="hljs-number">0</span>]
{<span class="hljs-string">&#x27;answers&#x27;</span>: {<span class="hljs-string">&#x27;a_id&#x27;</span>: [<span class="hljs-string">&#x27;c3d1aib&#x27;</span>, <span class="hljs-string">&#x27;c3d4lya&#x27;</span>],
  <span class="hljs-string">&#x27;score&#x27;</span>: [<span class="hljs-number">6</span>, <span class="hljs-number">3</span>],
  <span class="hljs-string">&#x27;text&#x27;</span>: [<span class="hljs-string">&quot;The velocity needed to remain in orbit is equal to the square root of Newton&#x27;s constant times the mass of earth divided by the distance from the center of the earth. I don&#x27;t know the altitude of that specific mission, but they&#x27;re usually around 300 km. That means he&#x27;s going 7-8 km/s.\\n\\nIn space there are no other forces acting on either the shuttle or the guy, so they stay in the same position relative to each other. If he were to become unable to return to the ship, he would presumably run out of oxygen, or slowly fall into the atmosphere and burn up.&quot;</span>,
   <span class="hljs-string">&quot;Hope you don&#x27;t mind me asking another question, but why aren&#x27;t there any stars visible in this photo?&quot;</span>]},
 <span class="hljs-string">&#x27;answers_urls&#x27;</span>: {<span class="hljs-string">&#x27;url&#x27;</span>: []},
 <span class="hljs-string">&#x27;document&#x27;</span>: <span class="hljs-string">&#x27;&#x27;</span>,
 <span class="hljs-string">&#x27;q_id&#x27;</span>: <span class="hljs-string">&#x27;nyxfp&#x27;</span>,
 <span class="hljs-string">&#x27;selftext&#x27;</span>: <span class="hljs-string">&#x27;_URL_0_\\n\\nThis was on the front page earlier and I have a few questions about it. Is it possible to calculate how fast the astronaut would be orbiting the earth? Also how does he stay close to the shuttle so that he can return safely, i.e is he orbiting at the same speed and can therefore stay next to it? And finally if his propulsion system failed, would he eventually re-enter the atmosphere and presumably die?&#x27;</span>,
 <span class="hljs-string">&#x27;selftext_urls&#x27;</span>: {<span class="hljs-string">&#x27;url&#x27;</span>: [<span class="hljs-string">&#x27;http://apod.nasa.gov/apod/image/1201/freeflyer_nasa_3000.jpg&#x27;</span>]},
 <span class="hljs-string">&#x27;subreddit&#x27;</span>: <span class="hljs-string">&#x27;askscience&#x27;</span>,
 <span class="hljs-string">&#x27;title&#x27;</span>: <span class="hljs-string">&#x27;Few questions about this space walk photograph.&#x27;</span>,
 <span class="hljs-string">&#x27;title_urls&#x27;</span>: {<span class="hljs-string">&#x27;url&#x27;</span>: []}}`}}),Ne=new ya({}),tt=new io({props:{id:"8PmhEIXhBvI"}}),lt=new Q({props:{code:`from transformers import AutoTokenizer

tokenizer = AutoTokenizer.from_pretrained("distilroberta-base")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;distilroberta-base&quot;</span>)`}}),rt=new Q({props:{code:`eli5 = eli5.flatten()
eli5["train"][0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>eli5 = eli5.flatten()
<span class="hljs-meta">&gt;&gt;&gt; </span>eli5[<span class="hljs-string">&quot;train&quot;</span>][<span class="hljs-number">0</span>]
{<span class="hljs-string">&#x27;answers.a_id&#x27;</span>: [<span class="hljs-string">&#x27;c3d1aib&#x27;</span>, <span class="hljs-string">&#x27;c3d4lya&#x27;</span>],
 <span class="hljs-string">&#x27;answers.score&#x27;</span>: [<span class="hljs-number">6</span>, <span class="hljs-number">3</span>],
 <span class="hljs-string">&#x27;answers.text&#x27;</span>: [<span class="hljs-string">&quot;The velocity needed to remain in orbit is equal to the square root of Newton&#x27;s constant times the mass of earth divided by the distance from the center of the earth. I don&#x27;t know the altitude of that specific mission, but they&#x27;re usually around 300 km. That means he&#x27;s going 7-8 km/s.\\n\\nIn space there are no other forces acting on either the shuttle or the guy, so they stay in the same position relative to each other. If he were to become unable to return to the ship, he would presumably run out of oxygen, or slowly fall into the atmosphere and burn up.&quot;</span>,
  <span class="hljs-string">&quot;Hope you don&#x27;t mind me asking another question, but why aren&#x27;t there any stars visible in this photo?&quot;</span>],
 <span class="hljs-string">&#x27;answers_urls.url&#x27;</span>: [],
 <span class="hljs-string">&#x27;document&#x27;</span>: <span class="hljs-string">&#x27;&#x27;</span>,
 <span class="hljs-string">&#x27;q_id&#x27;</span>: <span class="hljs-string">&#x27;nyxfp&#x27;</span>,
 <span class="hljs-string">&#x27;selftext&#x27;</span>: <span class="hljs-string">&#x27;_URL_0_\\n\\nThis was on the front page earlier and I have a few questions about it. Is it possible to calculate how fast the astronaut would be orbiting the earth? Also how does he stay close to the shuttle so that he can return safely, i.e is he orbiting at the same speed and can therefore stay next to it? And finally if his propulsion system failed, would he eventually re-enter the atmosphere and presumably die?&#x27;</span>,
 <span class="hljs-string">&#x27;selftext_urls.url&#x27;</span>: [<span class="hljs-string">&#x27;http://apod.nasa.gov/apod/image/1201/freeflyer_nasa_3000.jpg&#x27;</span>],
 <span class="hljs-string">&#x27;subreddit&#x27;</span>: <span class="hljs-string">&#x27;askscience&#x27;</span>,
 <span class="hljs-string">&#x27;title&#x27;</span>: <span class="hljs-string">&#x27;Few questions about this space walk photograph.&#x27;</span>,
 <span class="hljs-string">&#x27;title_urls.url&#x27;</span>: []}`}}),kt=new Q({props:{code:`def preprocess_function(examples):
    return tokenizer([" ".join(x) for x in examples["answers.text"]], truncation=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">preprocess_function</span>(<span class="hljs-params">examples</span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> tokenizer([<span class="hljs-string">&quot; &quot;</span>.join(x) <span class="hljs-keyword">for</span> x <span class="hljs-keyword">in</span> examples[<span class="hljs-string">&quot;answers.text&quot;</span>]], truncation=<span class="hljs-literal">True</span>)`}}),yt=new Q({props:{code:`tokenized_eli5 = eli5.map(
    preprocess_function,
    batched=True,
    num_proc=4,
    remove_columns=eli5["train"].column_names,
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>tokenized_eli5 = eli5.<span class="hljs-built_in">map</span>(
<span class="hljs-meta">... </span>    preprocess_function,
<span class="hljs-meta">... </span>    batched=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    num_proc=<span class="hljs-number">4</span>,
<span class="hljs-meta">... </span>    remove_columns=eli5[<span class="hljs-string">&quot;train&quot;</span>].column_names,
<span class="hljs-meta">... </span>)`}}),wt=new Q({props:{code:`block_size = 128


def group_texts(examples):
    concatenated_examples = {k: sum(examples[k], []) for k in examples.keys()}
    total_length = len(concatenated_examples[list(examples.keys())[0]])
    total_length = (total_length // block_size) * block_size
    result = {
        k: [t[i : i + block_size] for i in range(0, total_length, block_size)]
        for k, t in concatenated_examples.items()
    }
    result["labels"] = result["input_ids"].copy()
    return result`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>block_size = <span class="hljs-number">128</span>


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">group_texts</span>(<span class="hljs-params">examples</span>):
<span class="hljs-meta">... </span>    concatenated_examples = {k: <span class="hljs-built_in">sum</span>(examples[k], []) <span class="hljs-keyword">for</span> k <span class="hljs-keyword">in</span> examples.keys()}
<span class="hljs-meta">... </span>    total_length = <span class="hljs-built_in">len</span>(concatenated_examples[<span class="hljs-built_in">list</span>(examples.keys())[<span class="hljs-number">0</span>]])
<span class="hljs-meta">... </span>    total_length = (total_length // block_size) * block_size
<span class="hljs-meta">... </span>    result = {
<span class="hljs-meta">... </span>        k: [t[i : i + block_size] <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">0</span>, total_length, block_size)]
<span class="hljs-meta">... </span>        <span class="hljs-keyword">for</span> k, t <span class="hljs-keyword">in</span> concatenated_examples.items()
<span class="hljs-meta">... </span>    }
<span class="hljs-meta">... </span>    result[<span class="hljs-string">&quot;labels&quot;</span>] = result[<span class="hljs-string">&quot;input_ids&quot;</span>].copy()
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> result`}}),jt=new Q({props:{code:"lm_dataset = tokenized_eli5.map(group_texts, batched=True, num_proc=4)",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>lm_dataset = tokenized_eli5.<span class="hljs-built_in">map</span>(group_texts, batched=<span class="hljs-literal">True</span>, num_proc=<span class="hljs-number">4</span>)'}}),Gt=new hl({props:{pytorch:!0,tensorflow:!0,jax:!1,$$slots:{tensorflow:[yo],pytorch:[ko]},$$scope:{ctx:V}}}),qs=new ya({}),Jt=new hl({props:{pytorch:!0,tensorflow:!0,jax:!1,$$slots:{tensorflow:[Eo],pytorch:[jo]},$$scope:{ctx:V}}}),Zt=new Wa({props:{$$slots:{default:[To]},$$scope:{ctx:V}}}),zs=new ya({}),Ps=new Q({props:{code:'text = "The Milky Way is a <mask> galaxy."',highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>text = <span class="hljs-string">&quot;The Milky Way is a &lt;mask&gt; galaxy.&quot;</span>'}}),Rs=new Q({props:{code:`from transformers import pipeline

mask_filler = pipeline("fill-mask", "stevhliu/my_awesome_eli5_mlm_model")
mask_filler(text, top_k=3)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> pipeline

<span class="hljs-meta">&gt;&gt;&gt; </span>mask_filler = pipeline(<span class="hljs-string">&quot;fill-mask&quot;</span>, <span class="hljs-string">&quot;stevhliu/my_awesome_eli5_mlm_model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_filler(text, top_k=<span class="hljs-number">3</span>)
[{<span class="hljs-string">&#x27;score&#x27;</span>: <span class="hljs-number">0.5150994658470154</span>,
  <span class="hljs-string">&#x27;token&#x27;</span>: <span class="hljs-number">21300</span>,
  <span class="hljs-string">&#x27;token_str&#x27;</span>: <span class="hljs-string">&#x27; spiral&#x27;</span>,
  <span class="hljs-string">&#x27;sequence&#x27;</span>: <span class="hljs-string">&#x27;The Milky Way is a spiral galaxy.&#x27;</span>},
 {<span class="hljs-string">&#x27;score&#x27;</span>: <span class="hljs-number">0.07087188959121704</span>,
  <span class="hljs-string">&#x27;token&#x27;</span>: <span class="hljs-number">2232</span>,
  <span class="hljs-string">&#x27;token_str&#x27;</span>: <span class="hljs-string">&#x27; massive&#x27;</span>,
  <span class="hljs-string">&#x27;sequence&#x27;</span>: <span class="hljs-string">&#x27;The Milky Way is a massive galaxy.&#x27;</span>},
 {<span class="hljs-string">&#x27;score&#x27;</span>: <span class="hljs-number">0.06434620916843414</span>,
  <span class="hljs-string">&#x27;token&#x27;</span>: <span class="hljs-number">650</span>,
  <span class="hljs-string">&#x27;token_str&#x27;</span>: <span class="hljs-string">&#x27; small&#x27;</span>,
  <span class="hljs-string">&#x27;sequence&#x27;</span>: <span class="hljs-string">&#x27;The Milky Way is a small galaxy.&#x27;</span>}]`}}),ss=new hl({props:{pytorch:!0,tensorflow:!0,jax:!1,$$slots:{tensorflow:[zo],pytorch:[Mo]},$$scope:{ctx:V}}}),{c(){p=o("meta"),i=k(),m=o("h1"),y=o("a"),w=o("span"),T(v.$$.fragment),x=k(),D=o("span"),b=a("Masked language modeling"),j=k(),T(L.$$.fragment),F=k(),T(S.$$.fragment),H=k(),B=o("p"),ie=a(`Masked language modeling predicts a masked token in a sequence, and the model can attend to tokens bidirectionally. This
means the model has full access to the tokens on the left and right. Masked language modeling is great for tasks that
require a good contextual understanding of an entire sequence. BERT is an example of a masked language model.`),G=k(),C=o("p"),le=a("This guide will show you how to:"),U=k(),X=o("ol"),O=o("li"),W=a("Finetune "),N=o("a"),c=a("DistilRoBERTa"),E=a(" on the "),Y=o("a"),ue=a("r/askscience"),Z=a(" subset of the "),K=o("a"),oe=a("ELI5"),Fe=a(" dataset."),te=k(),Ae=o("li"),ce=a("Use your finetuned model for inference."),we=k(),T(ge.$$.fragment),ve=k(),J=o("p"),Me=a("Before you begin, make sure you have all the necessary libraries installed:"),ae=k(),T(he.$$.fragment),pe=k(),ke=o("p"),xe=a("We encourage you to log in to your Hugging Face account so you can upload and share your model with the community. When prompted, enter your token to log in:"),qe=k(),T(ne.$$.fragment),re=k(),se=o("h2"),me=o("a"),fe=o("span"),T($e.$$.fragment),u=k(),R=o("span"),de=a("Load ELI5 dataset"),ye=k(),g=o("p"),I=a(`Start by loading a smaller subset of the r/askscience subset of the ELI5 dataset from the \u{1F917} Datasets library. This\u2019ll
give you a chance to experiment and make sure everything works before spending more time training on the full dataset.`),je=k(),T(be.$$.fragment),Ee=k(),ee=o("p"),Ce=a("Split the dataset\u2019s "),ze=o("code"),Se=a("train_asks"),Te=a(" split into a train and test set with the "),Pe=o("a"),Xe=a("train_test_split"),He=a(" method:"),We=k(),T(Oe.$$.fragment),Be=k(),Ye=o("p"),os=a("Then take a look at an example:"),Ze=k(),T(et.$$.fragment),It=k(),Re=o("p"),ns=a("While this may look like a lot, you\u2019re only really interested in the "),Tt=o("code"),mt=a("text"),rs=a(" field. What\u2019s cool about language modeling tasks is you don\u2019t need labels (also known as an unsupervised task) because the next word "),At=o("em"),ft=a("is"),is=a(" the label."),Ot=k(),Ie=o("h2"),Ve=o("a"),Mt=o("span"),T(Ne.$$.fragment),ps=k(),qt=o("span"),ht=a("Preprocess"),Nt=k(),T(tt.$$.fragment),st=k(),Qe=o("p"),ms=a("For masked language modeling, the next step is to load a DistilRoBERTa tokenizer to process the "),Ge=o("code"),fs=a("text"),hs=a(" subfield:"),at=k(),T(lt.$$.fragment),St=k(),_e=o("p"),us=a("You\u2019ll notice from the example above, the "),zt=o("code"),ut=a("text"),cs=a(" field is actually nested inside "),Pt=o("code"),ct=a("answers"),ds=a(`. This means you\u2019ll need to e
xtract the `),Rt=o("code"),dt=a("text"),_s=a(" subfield from its nested structure with the "),ot=o("a"),Ke=o("code"),gs=a("flatten"),ks=a(" method:"),nt=k(),T(rt.$$.fragment),Ht=k(),Le=o("p"),$s=a("Each subfield is now a separate column as indicated by the "),Lt=o("code"),_t=a("answers"),ys=a(" prefix, and the "),Dt=o("code"),gt=a("text"),bs=a(` field is a list now. Instead
of tokenizing each sentence separately, convert the list to a string so you can jointly tokenize them.`),Ue=k(),_=o("p"),Ds=a("Here is how you can create a preprocessing function to convert the list to a string, and truncate sequences to be no longer than DistilRoBERTa\u2019s maximum input length:"),ws=k(),T(kt.$$.fragment),js=k(),De=o("p"),Fs=a("To apply the preprocessing function over the entire dataset, use \u{1F917} Datasets "),$t=o("a"),Cs=a("with_transform"),Bs=a(" method. You can speed up the "),Wt=o("code"),Is=a("map"),Os=a(" function by setting "),Yt=o("code"),Ns=a("batched=True"),Ss=a(" to process multiple elements of the dataset at once, and increasing the number of processes with "),Ut=o("code"),Hs=a("num_proc"),Ws=a(". Remove any columns you don\u2019t need:"),vs=k(),T(yt.$$.fragment),xs=k(),Ft=o("p"),Ys=a("Now you\u2019ll need a second preprocessing function to capture text truncated from the lengthier examples to avoid losing any information. This preprocessing function should:"),Es=k(),it=o("ul"),Xt=o("li"),Us=a("Concatenate all the text."),Xs=k(),bt=o("li"),Vs=a("Split the concatenated text into smaller chunks defined by "),Vt=o("code"),Qs=a("block_size"),Gs=a("."),Ts=k(),T(wt.$$.fragment),As=k(),pt=o("p"),Ks=a("Apply the "),Qt=o("code"),Js=a("group_texts"),Zs=a(" function over the entire dataset:"),Ms=k(),T(jt.$$.fragment),ba=k(),vt=o("p"),Ua=a("Now create a batch of examples using "),ea=o("a"),Xa=a("DataCollatorForLanguageModeling"),Va=a(". It\u2019s more efficient to "),ia=o("em"),Qa=a("dynamically pad"),Ga=a(" the sentences to the longest length in a batch during collation, instead of padding the whole dataset to the maximium length."),wa=k(),T(Gt.$$.fragment),ja=k(),Ct=o("h2"),Kt=o("a"),pa=o("span"),T(qs.$$.fragment),Ka=k(),ma=o("span"),Ja=a("Train"),va=k(),T(Jt.$$.fragment),xa=k(),T(Zt.$$.fragment),Ea=k(),Bt=o("h2"),es=o("a"),fa=o("span"),T(zs.$$.fragment),Za=k(),ha=o("span"),el=a("Inference"),Ta=k(),ta=o("p"),tl=a("Great, now that you\u2019ve finetuned a model, you can use it for inference!"),Aa=k(),ts=o("p"),sl=a("Come up with some text you\u2019d like the model to fill in the blank with, and use the special "),ua=o("code"),al=a("<mask>"),ll=a(" token to indicate the blank:"),Ma=k(),T(Ps.$$.fragment),qa=k(),Je=o("p"),ol=a("The simplest way to try out your finetuned model for inference is to use it in a "),sa=o("a"),nl=a("pipeline()"),rl=a(". Instantiate a "),ca=o("code"),il=a("pipeline"),pl=a(" for fill-mask with your model, and pass your text to it. If you like, you can use the "),da=o("code"),ml=a("top_k"),fl=a(" parameter to specify how many predictions to return:"),za=k(),T(Rs.$$.fragment),Pa=k(),T(ss.$$.fragment),this.h()},l(t){const h=ho('[data-svelte="svelte-1phssyn"]',document.head);p=n(h,"META",{name:!0,content:!0}),h.forEach(s),i=$(t),m=n(t,"H1",{class:!0});var Ls=r(m);y=n(Ls,"A",{id:!0,class:!0,href:!0});var _a=r(y);w=n(_a,"SPAN",{});var ga=r(w);A(v.$$.fragment,ga),ga.forEach(s),_a.forEach(s),x=$(Ls),D=n(Ls,"SPAN",{});var ka=r(D);b=l(ka,"Masked language modeling"),ka.forEach(s),Ls.forEach(s),j=$(t),A(L.$$.fragment,t),F=$(t),A(S.$$.fragment,t),H=$(t),B=n(t,"P",{});var $a=r(B);ie=l($a,`Masked language modeling predicts a masked token in a sequence, and the model can attend to tokens bidirectionally. This
means the model has full access to the tokens on the left and right. Masked language modeling is great for tasks that
require a good contextual understanding of an entire sequence. BERT is an example of a masked language model.`),$a.forEach(s),G=$(t),C=n(t,"P",{});var ul=r(C);le=l(ul,"This guide will show you how to:"),ul.forEach(s),U=$(t),X=n(t,"OL",{});var La=r(X);O=n(La,"LI",{});var as=r(O);W=l(as,"Finetune "),N=n(as,"A",{href:!0,rel:!0});var cl=r(N);c=l(cl,"DistilRoBERTa"),cl.forEach(s),E=l(as," on the "),Y=n(as,"A",{href:!0,rel:!0});var dl=r(Y);ue=l(dl,"r/askscience"),dl.forEach(s),Z=l(as," subset of the "),K=n(as,"A",{href:!0,rel:!0});var _l=r(K);oe=l(_l,"ELI5"),_l.forEach(s),Fe=l(as," dataset."),as.forEach(s),te=$(La),Ae=n(La,"LI",{});var gl=r(Ae);ce=l(gl,"Use your finetuned model for inference."),gl.forEach(s),La.forEach(s),we=$(t),A(ge.$$.fragment,t),ve=$(t),J=n(t,"P",{});var kl=r(J);Me=l(kl,"Before you begin, make sure you have all the necessary libraries installed:"),kl.forEach(s),ae=$(t),A(he.$$.fragment,t),pe=$(t),ke=n(t,"P",{});var $l=r(ke);xe=l($l,"We encourage you to log in to your Hugging Face account so you can upload and share your model with the community. When prompted, enter your token to log in:"),$l.forEach(s),qe=$(t),A(ne.$$.fragment,t),re=$(t),se=n(t,"H2",{class:!0});var Da=r(se);me=n(Da,"A",{id:!0,class:!0,href:!0});var yl=r(me);fe=n(yl,"SPAN",{});var bl=r(fe);A($e.$$.fragment,bl),bl.forEach(s),yl.forEach(s),u=$(Da),R=n(Da,"SPAN",{});var wl=r(R);de=l(wl,"Load ELI5 dataset"),wl.forEach(s),Da.forEach(s),ye=$(t),g=n(t,"P",{});var jl=r(g);I=l(jl,`Start by loading a smaller subset of the r/askscience subset of the ELI5 dataset from the \u{1F917} Datasets library. This\u2019ll
give you a chance to experiment and make sure everything works before spending more time training on the full dataset.`),jl.forEach(s),je=$(t),A(be.$$.fragment,t),Ee=$(t),ee=n(t,"P",{});var aa=r(ee);Ce=l(aa,"Split the dataset\u2019s "),ze=n(aa,"CODE",{});var vl=r(ze);Se=l(vl,"train_asks"),vl.forEach(s),Te=l(aa," split into a train and test set with the "),Pe=n(aa,"A",{href:!0,rel:!0});var xl=r(Pe);Xe=l(xl,"train_test_split"),xl.forEach(s),He=l(aa," method:"),aa.forEach(s),We=$(t),A(Oe.$$.fragment,t),Be=$(t),Ye=n(t,"P",{});var El=r(Ye);os=l(El,"Then take a look at an example:"),El.forEach(s),Ze=$(t),A(et.$$.fragment,t),It=$(t),Re=n(t,"P",{});var la=r(Re);ns=l(la,"While this may look like a lot, you\u2019re only really interested in the "),Tt=n(la,"CODE",{});var Tl=r(Tt);mt=l(Tl,"text"),Tl.forEach(s),rs=l(la," field. What\u2019s cool about language modeling tasks is you don\u2019t need labels (also known as an unsupervised task) because the next word "),At=n(la,"EM",{});var Al=r(At);ft=l(Al,"is"),Al.forEach(s),is=l(la," the label."),la.forEach(s),Ot=$(t),Ie=n(t,"H2",{class:!0});var Fa=r(Ie);Ve=n(Fa,"A",{id:!0,class:!0,href:!0});var Ml=r(Ve);Mt=n(Ml,"SPAN",{});var ql=r(Mt);A(Ne.$$.fragment,ql),ql.forEach(s),Ml.forEach(s),ps=$(Fa),qt=n(Fa,"SPAN",{});var zl=r(qt);ht=l(zl,"Preprocess"),zl.forEach(s),Fa.forEach(s),Nt=$(t),A(tt.$$.fragment,t),st=$(t),Qe=n(t,"P",{});var Ca=r(Qe);ms=l(Ca,"For masked language modeling, the next step is to load a DistilRoBERTa tokenizer to process the "),Ge=n(Ca,"CODE",{});var Pl=r(Ge);fs=l(Pl,"text"),Pl.forEach(s),hs=l(Ca," subfield:"),Ca.forEach(s),at=$(t),A(lt.$$.fragment,t),St=$(t),_e=n(t,"P",{});var xt=r(_e);us=l(xt,"You\u2019ll notice from the example above, the "),zt=n(xt,"CODE",{});var Rl=r(zt);ut=l(Rl,"text"),Rl.forEach(s),cs=l(xt," field is actually nested inside "),Pt=n(xt,"CODE",{});var Ll=r(Pt);ct=l(Ll,"answers"),Ll.forEach(s),ds=l(xt,`. This means you\u2019ll need to e
xtract the `),Rt=n(xt,"CODE",{});var Dl=r(Rt);dt=l(Dl,"text"),Dl.forEach(s),_s=l(xt," subfield from its nested structure with the "),ot=n(xt,"A",{href:!0,rel:!0});var Fl=r(ot);Ke=n(Fl,"CODE",{});var Cl=r(Ke);gs=l(Cl,"flatten"),Cl.forEach(s),Fl.forEach(s),ks=l(xt," method:"),xt.forEach(s),nt=$(t),A(rt.$$.fragment,t),Ht=$(t),Le=n(t,"P",{});var oa=r(Le);$s=l(oa,"Each subfield is now a separate column as indicated by the "),Lt=n(oa,"CODE",{});var Bl=r(Lt);_t=l(Bl,"answers"),Bl.forEach(s),ys=l(oa," prefix, and the "),Dt=n(oa,"CODE",{});var Il=r(Dt);gt=l(Il,"text"),Il.forEach(s),bs=l(oa,` field is a list now. Instead
of tokenizing each sentence separately, convert the list to a string so you can jointly tokenize them.`),oa.forEach(s),Ue=$(t),_=n(t,"P",{});var Ol=r(_);Ds=l(Ol,"Here is how you can create a preprocessing function to convert the list to a string, and truncate sequences to be no longer than DistilRoBERTa\u2019s maximum input length:"),Ol.forEach(s),ws=$(t),A(kt.$$.fragment,t),js=$(t),De=n(t,"P",{});var Et=r(De);Fs=l(Et,"To apply the preprocessing function over the entire dataset, use \u{1F917} Datasets "),$t=n(Et,"A",{href:!0,rel:!0});var Nl=r($t);Cs=l(Nl,"with_transform"),Nl.forEach(s),Bs=l(Et," method. You can speed up the "),Wt=n(Et,"CODE",{});var Sl=r(Wt);Is=l(Sl,"map"),Sl.forEach(s),Os=l(Et," function by setting "),Yt=n(Et,"CODE",{});var Hl=r(Yt);Ns=l(Hl,"batched=True"),Hl.forEach(s),Ss=l(Et," to process multiple elements of the dataset at once, and increasing the number of processes with "),Ut=n(Et,"CODE",{});var Wl=r(Ut);Hs=l(Wl,"num_proc"),Wl.forEach(s),Ws=l(Et,". Remove any columns you don\u2019t need:"),Et.forEach(s),vs=$(t),A(yt.$$.fragment,t),xs=$(t),Ft=n(t,"P",{});var Yl=r(Ft);Ys=l(Yl,"Now you\u2019ll need a second preprocessing function to capture text truncated from the lengthier examples to avoid losing any information. This preprocessing function should:"),Yl.forEach(s),Es=$(t),it=n(t,"UL",{});var Ba=r(it);Xt=n(Ba,"LI",{});var Ul=r(Xt);Us=l(Ul,"Concatenate all the text."),Ul.forEach(s),Xs=$(Ba),bt=n(Ba,"LI",{});var Ia=r(bt);Vs=l(Ia,"Split the concatenated text into smaller chunks defined by "),Vt=n(Ia,"CODE",{});var Xl=r(Vt);Qs=l(Xl,"block_size"),Xl.forEach(s),Gs=l(Ia,"."),Ia.forEach(s),Ba.forEach(s),Ts=$(t),A(wt.$$.fragment,t),As=$(t),pt=n(t,"P",{});var Oa=r(pt);Ks=l(Oa,"Apply the "),Qt=n(Oa,"CODE",{});var Vl=r(Qt);Js=l(Vl,"group_texts"),Vl.forEach(s),Zs=l(Oa," function over the entire dataset:"),Oa.forEach(s),Ms=$(t),A(jt.$$.fragment,t),ba=$(t),vt=n(t,"P",{});var na=r(vt);Ua=l(na,"Now create a batch of examples using "),ea=n(na,"A",{href:!0});var Ql=r(ea);Xa=l(Ql,"DataCollatorForLanguageModeling"),Ql.forEach(s),Va=l(na,". It\u2019s more efficient to "),ia=n(na,"EM",{});var Gl=r(ia);Qa=l(Gl,"dynamically pad"),Gl.forEach(s),Ga=l(na," the sentences to the longest length in a batch during collation, instead of padding the whole dataset to the maximium length."),na.forEach(s),wa=$(t),A(Gt.$$.fragment,t),ja=$(t),Ct=n(t,"H2",{class:!0});var Na=r(Ct);Kt=n(Na,"A",{id:!0,class:!0,href:!0});var Kl=r(Kt);pa=n(Kl,"SPAN",{});var Jl=r(pa);A(qs.$$.fragment,Jl),Jl.forEach(s),Kl.forEach(s),Ka=$(Na),ma=n(Na,"SPAN",{});var Zl=r(ma);Ja=l(Zl,"Train"),Zl.forEach(s),Na.forEach(s),va=$(t),A(Jt.$$.fragment,t),xa=$(t),A(Zt.$$.fragment,t),Ea=$(t),Bt=n(t,"H2",{class:!0});var Sa=r(Bt);es=n(Sa,"A",{id:!0,class:!0,href:!0});var eo=r(es);fa=n(eo,"SPAN",{});var to=r(fa);A(zs.$$.fragment,to),to.forEach(s),eo.forEach(s),Za=$(Sa),ha=n(Sa,"SPAN",{});var so=r(ha);el=l(so,"Inference"),so.forEach(s),Sa.forEach(s),Ta=$(t),ta=n(t,"P",{});var ao=r(ta);tl=l(ao,"Great, now that you\u2019ve finetuned a model, you can use it for inference!"),ao.forEach(s),Aa=$(t),ts=n(t,"P",{});var Ha=r(ts);sl=l(Ha,"Come up with some text you\u2019d like the model to fill in the blank with, and use the special "),ua=n(Ha,"CODE",{});var lo=r(ua);al=l(lo,"<mask>"),lo.forEach(s),ll=l(Ha," token to indicate the blank:"),Ha.forEach(s),Ma=$(t),A(Ps.$$.fragment,t),qa=$(t),Je=n(t,"P",{});var ls=r(Je);ol=l(ls,"The simplest way to try out your finetuned model for inference is to use it in a "),sa=n(ls,"A",{href:!0});var oo=r(sa);nl=l(oo,"pipeline()"),oo.forEach(s),rl=l(ls,". Instantiate a "),ca=n(ls,"CODE",{});var no=r(ca);il=l(no,"pipeline"),no.forEach(s),pl=l(ls," for fill-mask with your model, and pass your text to it. If you like, you can use the "),da=n(ls,"CODE",{});var ro=r(da);ml=l(ro,"top_k"),ro.forEach(s),fl=l(ls," parameter to specify how many predictions to return:"),ls.forEach(s),za=$(t),A(Rs.$$.fragment,t),Pa=$(t),A(ss.$$.fragment,t),this.h()},h(){d(p,"name","hf:doc:metadata"),d(p,"content",JSON.stringify(Ro)),d(y,"id","masked-language-modeling"),d(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(y,"href","#masked-language-modeling"),d(m,"class","relative group"),d(N,"href","https://huggingface.co/distilroberta-base"),d(N,"rel","nofollow"),d(Y,"href","https://www.reddit.com/r/askscience/"),d(Y,"rel","nofollow"),d(K,"href","https://huggingface.co/datasets/eli5"),d(K,"rel","nofollow"),d(me,"id","load-eli5-dataset"),d(me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(me,"href","#load-eli5-dataset"),d(se,"class","relative group"),d(Pe,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.train_test_split"),d(Pe,"rel","nofollow"),d(Ve,"id","preprocess"),d(Ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Ve,"href","#preprocess"),d(Ie,"class","relative group"),d(ot,"href","https://huggingface.co/docs/datasets/process.html#flatten"),d(ot,"rel","nofollow"),d($t,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.with_transform"),d($t,"rel","nofollow"),d(ea,"href","/docs/transformers/main/en/main_classes/data_collator#transformers.DataCollatorForLanguageModeling"),d(Kt,"id","train"),d(Kt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Kt,"href","#train"),d(Ct,"class","relative group"),d(es,"id","inference"),d(es,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(es,"href","#inference"),d(Bt,"class","relative group"),d(sa,"href","/docs/transformers/main/en/main_classes/pipelines#transformers.pipeline")},m(t,h){e(document.head,p),f(t,i,h),f(t,m,h),e(m,y),e(y,w),M(v,w,null),e(m,x),e(m,D),e(D,b),f(t,j,h),M(L,t,h),f(t,F,h),M(S,t,h),f(t,H,h),f(t,B,h),e(B,ie),f(t,G,h),f(t,C,h),e(C,le),f(t,U,h),f(t,X,h),e(X,O),e(O,W),e(O,N),e(N,c),e(O,E),e(O,Y),e(Y,ue),e(O,Z),e(O,K),e(K,oe),e(O,Fe),e(X,te),e(X,Ae),e(Ae,ce),f(t,we,h),M(ge,t,h),f(t,ve,h),f(t,J,h),e(J,Me),f(t,ae,h),M(he,t,h),f(t,pe,h),f(t,ke,h),e(ke,xe),f(t,qe,h),M(ne,t,h),f(t,re,h),f(t,se,h),e(se,me),e(me,fe),M($e,fe,null),e(se,u),e(se,R),e(R,de),f(t,ye,h),f(t,g,h),e(g,I),f(t,je,h),M(be,t,h),f(t,Ee,h),f(t,ee,h),e(ee,Ce),e(ee,ze),e(ze,Se),e(ee,Te),e(ee,Pe),e(Pe,Xe),e(ee,He),f(t,We,h),M(Oe,t,h),f(t,Be,h),f(t,Ye,h),e(Ye,os),f(t,Ze,h),M(et,t,h),f(t,It,h),f(t,Re,h),e(Re,ns),e(Re,Tt),e(Tt,mt),e(Re,rs),e(Re,At),e(At,ft),e(Re,is),f(t,Ot,h),f(t,Ie,h),e(Ie,Ve),e(Ve,Mt),M(Ne,Mt,null),e(Ie,ps),e(Ie,qt),e(qt,ht),f(t,Nt,h),M(tt,t,h),f(t,st,h),f(t,Qe,h),e(Qe,ms),e(Qe,Ge),e(Ge,fs),e(Qe,hs),f(t,at,h),M(lt,t,h),f(t,St,h),f(t,_e,h),e(_e,us),e(_e,zt),e(zt,ut),e(_e,cs),e(_e,Pt),e(Pt,ct),e(_e,ds),e(_e,Rt),e(Rt,dt),e(_e,_s),e(_e,ot),e(ot,Ke),e(Ke,gs),e(_e,ks),f(t,nt,h),M(rt,t,h),f(t,Ht,h),f(t,Le,h),e(Le,$s),e(Le,Lt),e(Lt,_t),e(Le,ys),e(Le,Dt),e(Dt,gt),e(Le,bs),f(t,Ue,h),f(t,_,h),e(_,Ds),f(t,ws,h),M(kt,t,h),f(t,js,h),f(t,De,h),e(De,Fs),e(De,$t),e($t,Cs),e(De,Bs),e(De,Wt),e(Wt,Is),e(De,Os),e(De,Yt),e(Yt,Ns),e(De,Ss),e(De,Ut),e(Ut,Hs),e(De,Ws),f(t,vs,h),M(yt,t,h),f(t,xs,h),f(t,Ft,h),e(Ft,Ys),f(t,Es,h),f(t,it,h),e(it,Xt),e(Xt,Us),e(it,Xs),e(it,bt),e(bt,Vs),e(bt,Vt),e(Vt,Qs),e(bt,Gs),f(t,Ts,h),M(wt,t,h),f(t,As,h),f(t,pt,h),e(pt,Ks),e(pt,Qt),e(Qt,Js),e(pt,Zs),f(t,Ms,h),M(jt,t,h),f(t,ba,h),f(t,vt,h),e(vt,Ua),e(vt,ea),e(ea,Xa),e(vt,Va),e(vt,ia),e(ia,Qa),e(vt,Ga),f(t,wa,h),M(Gt,t,h),f(t,ja,h),f(t,Ct,h),e(Ct,Kt),e(Kt,pa),M(qs,pa,null),e(Ct,Ka),e(Ct,ma),e(ma,Ja),f(t,va,h),M(Jt,t,h),f(t,xa,h),M(Zt,t,h),f(t,Ea,h),f(t,Bt,h),e(Bt,es),e(es,fa),M(zs,fa,null),e(Bt,Za),e(Bt,ha),e(ha,el),f(t,Ta,h),f(t,ta,h),e(ta,tl),f(t,Aa,h),f(t,ts,h),e(ts,sl),e(ts,ua),e(ua,al),e(ts,ll),f(t,Ma,h),M(Ps,t,h),f(t,qa,h),f(t,Je,h),e(Je,ol),e(Je,sa),e(sa,nl),e(Je,rl),e(Je,ca),e(ca,il),e(Je,pl),e(Je,da),e(da,ml),e(Je,fl),f(t,za,h),M(Rs,t,h),f(t,Pa,h),M(ss,t,h),Ra=!0},p(t,[h]){const Ls={};h&2&&(Ls.$$scope={dirty:h,ctx:t}),ge.$set(Ls);const _a={};h&2&&(_a.$$scope={dirty:h,ctx:t}),Gt.$set(_a);const ga={};h&2&&(ga.$$scope={dirty:h,ctx:t}),Jt.$set(ga);const ka={};h&2&&(ka.$$scope={dirty:h,ctx:t}),Zt.$set(ka);const $a={};h&2&&($a.$$scope={dirty:h,ctx:t}),ss.$set($a)},i(t){Ra||(q(v.$$.fragment,t),q(L.$$.fragment,t),q(S.$$.fragment,t),q(ge.$$.fragment,t),q(he.$$.fragment,t),q(ne.$$.fragment,t),q($e.$$.fragment,t),q(be.$$.fragment,t),q(Oe.$$.fragment,t),q(et.$$.fragment,t),q(Ne.$$.fragment,t),q(tt.$$.fragment,t),q(lt.$$.fragment,t),q(rt.$$.fragment,t),q(kt.$$.fragment,t),q(yt.$$.fragment,t),q(wt.$$.fragment,t),q(jt.$$.fragment,t),q(Gt.$$.fragment,t),q(qs.$$.fragment,t),q(Jt.$$.fragment,t),q(Zt.$$.fragment,t),q(zs.$$.fragment,t),q(Ps.$$.fragment,t),q(Rs.$$.fragment,t),q(ss.$$.fragment,t),Ra=!0)},o(t){z(v.$$.fragment,t),z(L.$$.fragment,t),z(S.$$.fragment,t),z(ge.$$.fragment,t),z(he.$$.fragment,t),z(ne.$$.fragment,t),z($e.$$.fragment,t),z(be.$$.fragment,t),z(Oe.$$.fragment,t),z(et.$$.fragment,t),z(Ne.$$.fragment,t),z(tt.$$.fragment,t),z(lt.$$.fragment,t),z(rt.$$.fragment,t),z(kt.$$.fragment,t),z(yt.$$.fragment,t),z(wt.$$.fragment,t),z(jt.$$.fragment,t),z(Gt.$$.fragment,t),z(qs.$$.fragment,t),z(Jt.$$.fragment,t),z(Zt.$$.fragment,t),z(zs.$$.fragment,t),z(Ps.$$.fragment,t),z(Rs.$$.fragment,t),z(ss.$$.fragment,t),Ra=!1},d(t){s(p),t&&s(i),t&&s(m),P(v),t&&s(j),P(L,t),t&&s(F),P(S,t),t&&s(H),t&&s(B),t&&s(G),t&&s(C),t&&s(U),t&&s(X),t&&s(we),P(ge,t),t&&s(ve),t&&s(J),t&&s(ae),P(he,t),t&&s(pe),t&&s(ke),t&&s(qe),P(ne,t),t&&s(re),t&&s(se),P($e),t&&s(ye),t&&s(g),t&&s(je),P(be,t),t&&s(Ee),t&&s(ee),t&&s(We),P(Oe,t),t&&s(Be),t&&s(Ye),t&&s(Ze),P(et,t),t&&s(It),t&&s(Re),t&&s(Ot),t&&s(Ie),P(Ne),t&&s(Nt),P(tt,t),t&&s(st),t&&s(Qe),t&&s(at),P(lt,t),t&&s(St),t&&s(_e),t&&s(nt),P(rt,t),t&&s(Ht),t&&s(Le),t&&s(Ue),t&&s(_),t&&s(ws),P(kt,t),t&&s(js),t&&s(De),t&&s(vs),P(yt,t),t&&s(xs),t&&s(Ft),t&&s(Es),t&&s(it),t&&s(Ts),P(wt,t),t&&s(As),t&&s(pt),t&&s(Ms),P(jt,t),t&&s(ba),t&&s(vt),t&&s(wa),P(Gt,t),t&&s(ja),t&&s(Ct),P(qs),t&&s(va),P(Jt,t),t&&s(xa),P(Zt,t),t&&s(Ea),t&&s(Bt),P(zs),t&&s(Ta),t&&s(ta),t&&s(Aa),t&&s(ts),t&&s(Ma),P(Ps,t),t&&s(qa),t&&s(Je),t&&s(za),P(Rs,t),t&&s(Pa),P(ss,t)}}}const Ro={local:"masked-language-modeling",sections:[{local:"load-eli5-dataset",title:"Load ELI5 dataset"},{local:"preprocess",title:"Preprocess"},{local:"train",title:"Train"},{local:"inference",title:"Inference"}],title:"Masked language modeling"};function Lo(V){return uo(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class So extends po{constructor(p){super();mo(this,p,Lo,Po,fo,{})}}export{So as default,Ro as metadata};
